# JacoBot

Jacobot is a robot that moves on a carpet and is controlled wirelessly by the jacopad.

## Bot

### Shematic

`/jacobot/arduino/shematics/shematic.png`
![picture](https://git.afpy.org/Adrien/JacoBot/raw/branch/main/jacobot/arduino/shematics/shematic.png)

### How it works

Jacobot moves precisely and adapts to the terrain thanks to encoder motors.

### Design

All parts of the JacoPad's tokens tokens are in `/jacobot/parts/tokens/` and `/jacobot/arduino/models/`

## Wireless protocol

The Jacobot and the Jacopad talk via [NRF24L01](https://pecquery.wixsite.com/arduino-passion/le-transmetteur-radio-nrf24l01) following this protocol:

- **Use canal 120**
- **24-character message**  
  Exemple :

```
"JACOFFRLfLfNNNFFLRLN07"
 \__/\________/\____/\/
  1      2       3   4

- 1: The first part will always be "JACO",
  to differentiate it from other projects using the same canal.

- 2: The second part is the 10 tokens placed on the normal slots.
  "F" : Forward
  "L" : Left
  "R" : Right
  "f" : Function
  "N" : Nothing

- 3: The third part is the same that the second but for the
  function slots and with only 6 tokens.

- 4: The fourth part is the checksum of the 3 others.
```
