// Made by Linux_Hat
#include "car.h"
#include "motorEncoder.h"
#define pi 3.1415

Car::Car(MotorEncoder* left, MotorEncoder* right, float distance_beetween_motors) 
    : m_left(left), m_right(right), m_distance_beetween_motors(distance_beetween_motors) {
}

void Car::forward(float distance, double setPoint) { //distance : mm
    const float m1_mmp = pi*(*m_left).m_radius*2/(*m_left).m_ratio; // mm/pulse for m1
    const float m2_mmp = pi*(*m_right).m_radius*2/(*m_right).m_ratio; // mm/pulse for m2
    double m1_duration = 0;
    double m2_duration = 0;
    m_left->setPoint = setPoint;
    m_right->setPoint = setPoint/m2_mmp*m1_mmp;
    while(m1_duration<distance/m1_mmp && m2_duration<distance/m2_mmp) {
        if(m1_duration<distance/m1_mmp) {
            m1_duration+=m_left->compute(0);
            m_left->advance();
        } else {m_left->stop();}

        if(m2_duration<distance/m2_mmp) {
            m2_duration+m_right->compute(0);
            m_right->advance();
        } else {m_right->stop();}
    }
    m_left->stop();
    m_right->stop();
}

void Car::turn(float angle, double setPoint) { //angle : degre
    float distance = pi*m_distance_beetween_motors/360*angle;
    const float m1_mmp = pi*(*m_left).m_radius*2/(*m_left).m_ratio; // mm/pulse for m1
    const float m2_mmp = pi*(*m_right).m_radius*2/(*m_right).m_ratio; // mm/pulse for m2
    double duration = 0;
    m_left->setPoint = setPoint;
    m_right->setPoint = setPoint/m2_mmp*m1_mmp;
    if(angle>0) {
        const double pulse_goal = distance/m1_mmp;
        while(duration<pulse_goal) {
            duration+=m_left->compute(0);
            m_left->advance();
            m_right->compute(0);
            m_right->back();
        }
    } else if(angle<0) {
        const double pulse_goal = distance/m2_mmp;
        while(duration<pulse_goal) {
            duration+=m_right->compute(0);
            m_right->advance();
            m_left->compute(0);
            m_left->back();
        }
    }
    m_left->stop();
    m_right->stop();
    return;
}