// Made by Linux_Hat
#include <Arduino.h>
#include "radio.h"
#include "motorEncoder.h"
#include "car.h"

#define MLEFT_ENC_PIN_A 3
#define MLEFT_ENC_PIN_B A4
#define MLEFT_E_MOTOR 5
#define MLEFT_M_MOTOR 4
#define MLEFT_RATIO 120
#define MLEFT_RADIUS 3.3

#define MRIGHT_ENC_PIN_A 2
#define MRIGHT_ENC_PIN_B A3
#define MRIGHT_E_MOTOR 10
#define MRIGHT_M_MOTOR 8
#define MRIGHT_RATIO 120
#define MRIGHT_RADIUS 3.3

#define LED_ORANGE 12

#define SIZE 500
#define SPEED 50

MotorEncoder m1(MLEFT_ENC_PIN_A, MLEFT_ENC_PIN_B, MLEFT_E_MOTOR, MLEFT_M_MOTOR, MLEFT_RATIO, MLEFT_RADIUS); // Initialise motor
MotorEncoder m2(MRIGHT_ENC_PIN_A, MRIGHT_ENC_PIN_B, MRIGHT_E_MOTOR, MRIGHT_M_MOTOR, MRIGHT_RATIO, MRIGHT_RADIUS); // Initialise motor with pins

Car car(&m1, &m2, 110);

float m1_duration = 0;
float m2_duration = 0;

void encoder_handler_m1() {
  m1.wheelSpeed();  // Call wheelSpeed() of the m1 MotorEncoder instance
}

void encoder_handler_m2() {
  m2.wheelSpeed();  // Call wheelSpeed() of the m2 MotorEncoder instance 
}

Radio* radio;

void setup() {
  Serial.begin(9600);
  pinMode(LED_ORANGE, OUTPUT);
  radio = new Radio(120, 9, 7);
  m1.EncoderHandlerInit(encoder_handler_m1);
  m2.EncoderHandlerInit(encoder_handler_m2);
  Serial.println("Car started");
}

void function(int fn_lenght) {
  for (int j=14; j<14+fn_lenght; j++){
    if(radio->message[j] == (char)"F") {
      car.forward(SIZE, SPEED);
    } else if(radio->message[j] == (char)"R") {
      car.turn(90, SPEED);
    } else if(radio->message[j] == (char)"L") {
      car.turn(-90, SPEED);
    } else if(radio->message[j] == (char)"f") {
      function(fn_lenght);
    } else if(radio->message[j] == (char)"N") {
      delay(800);
    }
  }
}

void loop() {
  if (radio->read() && strncmp(radio->message, "JACO", 4) == 0){
    char checksum_check[2] = {radio->message[22], radio->message[23]};
    char checksum[] = "AA";
    for(int i=0; i<11; i++) {
        checksum[0] ^= radio->message[i*2];
        checksum[1] ^= radio->message[i*2+1];
    }

    if(strncmp(checksum_check, checksum, 2) == 0){
      int lenght = 10;
      int fn_lenght = 6;
      for (int i=13; i>3; i--){
        if(radio->message[i] != (char)"N") {
          break;
        }
        lenght--;
      }
      for (int i=19; i>13; i--){
        if(radio->message[i] != (char)"N") {
          break;
        }
        fn_lenght--;
      }

      for (int i=4; i<4+lenght; i++){
        if(radio->message[i] == (char)"F") {
          car.forward(SIZE, SPEED);
        } else if(radio->message[i] == (char)"R") {
          car.turn(90, SPEED);
        } else if(radio->message[i] == (char)"L") {
          car.turn(-90, SPEED);
        } else if(radio->message[i] == (char)"f") {
          function(fn_lenght);
        } else if(radio->message[i] == (char)"N") {
          delay(800);
        }
      }
    } 
  }
}
