#pragma once
#include <PID_v1.h>
#include <Arduino.h>

class MotorEncoder {
    private:
        uint8_t encoder0PinALast; //the number of the pulses
        boolean direction; //the rotation direction
        boolean result;
        PID* myPID;
        double val_output; //Power supplied to the motor PWM value.
        double Kp = 0.6, Ki = 5, Kd = 0;
        double abs_duration;
        uint8_t m_encoder0pinA; //A pin
        uint8_t m_encoder0pinB; //B pin 
        int m_E_left; //The enabling of L298PDC motor driver board connection to the digital interface port 5
        int m_M_left;

    public:
        float m_radius, m_ratio;
        double duration;
        double setPoint;

        MotorEncoder(uint8_t encoder0pinA, uint8_t encoder0pinB, int E_left, int M_left, float ratio, float radius);

        void EncoderHandlerInit(void (*ISR)(void));
        void wheelSpeed();
        void advance();
        void back();
        void stop();
        double compute(int debug);
};